#include "slick!.h"
#include "menueng.h"
#include "graphscr.h"

/*
** Input function for implementing CUA/SAA menus.
*/
int far cdecl gcuakey(ME_MENU far *m)
{
int x,y,c,b;
static int dragging,lastx,lasty;
ME_MSG far *message;
	if (!dragging)
		lastx=lasty=-1;
	while (1) {
		_mousepress(LEFT,&x,&y,&c);		/* read mouse */
		if (c) {
			dragging=-1;
			goto select;
		}
		b=_mousestatus(&x,&y);			/* get location */
		if (x!=lastx || y!=lasty) {		/* if moved... */
			gs_refresh();
			lastx=x;
			lasty=y;					/* remember new location */
			if ((b&1) && dragging) {	/* if we're still dragging */
select:
				message=pathfinder(m,x,y);	/* search for path */
				if (message!=NULL) {		/* if found... */
					if (message->message[0]==ME_ESC_KEY &&
						message->message[1]==ME_CR_KEY && dragging!=-1) {
skipmsg:
							(*message->eofmsg)(message);
							return 0;
					}
					if (!(message->message[message->index]&ME_IT_DOOR) ||
							message->message[message->index]&ME_IT_DIS) {
						if (message->index==2 && message->message[0]==
							ME_CR_KEY && dragging>0)
								goto skipmsg;

						message->message[message->index-2]=ME_CSHOW_KEY;
					}
					else {
						message->message[message->index-2]=ME_CSHOW_KEY;
						message->message[message->index-1]=ME_CR_KEY;
						message->message[message->index]=ME_CHIDE_KEY;
						message->message[message->index+1]=0;
					}
					dragging=1;
					message->index=0;
					menueng(ME_MESSAGE,message);
					return 0;
				}
				else {
					if (dragging!=-2) {
						dragging=-2;
						if (m->back!=NULL)
							return ME_CHIDE_KEY;
					}
				}
			}
		}
		if ((!(b&1)) && dragging) {		/* button released on drag */
			dragging=0;					/* stop dragging */
			b=_mouserelease(0,&x,&y,&c);/* read mouse */
			message=pathfinder(m,x,y);	/* search for path */
			if (message!=NULL) {
				if (message->message[message->index]&ME_IT_DOOR) {
					(*message->eofmsg)(message);
					return ME_CSHOW_KEY;
				}
				message->message[message->index-2]=ME_CSHOW_KEY;
				message->message[message->index-1]=ME_CR_KEY;
				message->message[message->index]=0;
				message->index=0;
				menueng(ME_MESSAGE,message);
				return 0;
			}
			return ME_CSHOW_KEY;
		}
		if (testkey())
			return waitkey();
	}
}
